<template>
    <div>
        <h1 class="uk-heading-medium uk-margin-top uk-heading-small">
            Suivi des élèves
        </h1>
        <div>
            <p>
                Cette page vous indique les problèmes que peuvent rencontrer vos
                élèves.
            </p>
        </div>
        <div class="uk-margin">
            <select
                class="uk-select"
                v-on:input="filtrerSuivis($event.target.value)"
            >
                <option v-for="classe in classes" :key="classe.nomClasse">{{
                    classe.nomClasse
                }}</option>
            </select>
        </div>
        <table
            class="uk-table uk-table-middle uk-table-striped uk-table-small uk-table-hover"
            v-if="suivis"
        >
            <thead>
                <tr>
                    <td class="uk-text-center">Nom</td>
                    <td class="uk-text-center">Total exercices</td>
                    <td class="uk-text-center">Nouveaux</td>
                    <td class="uk-text-center">En révision</td>
                    <td class="uk-text-center">Maitrisés</td>
                    <td class="uk-text-center">Nouveaux en erreur</td>
                    <td class="uk-text-center">Erreurs fréquentes</td>
                    <td class="uk-text-center">Questions</td>
                </tr>
            </thead>
            <ElementSuiviEleve
                v-for="suivi in suivisAAfficher"
                :key="suivi.eleve.id"
                :suivi="suivi"
            />
        </table>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import Axios from '@/auth/axiosAuth';
import ElementSuiviEleve from './ElementSuiviEleve.vue';
import UtilisateurSorter from '@/components/outils/UtilisateurSorter';
@Component({
    components: { ElementSuiviEleve }
})
export default class SuiviEleve extends Vue {
    private classes: any[] = [];
    private suivis: any[] = [];
    private suivisAAfficher: any[] = [];

    beforeRouteEnter(to, from, next) {
        next(vm =>
            Axios.get('suivieleve/' + vm.$auth.user.id, response => {
                vm.classes = response.data;
                vm.suivis = vm.classes[0].suivisEleves;
                vm.suivisAAfficher = vm.suivis;
                UtilisateurSorter.comparerListeSelonUtilisateur(
                    vm.suivisAAfficher,
                    element => element.eleve
                );
            })
        );
    }

    filtrerSuivis(nomClasseSelectionnee: string) {
        const classeSelectionnee = this.classes.find(
            classe => classe.nomClasse === nomClasseSelectionnee
        );
        this.suivisAAfficher = classeSelectionnee.suivisEleves;
        UtilisateurSorter.comparerListeSelonUtilisateur(
            this.suivisAAfficher,
            element => element.eleve
        );
    }
}
</script>
